package de.fraunhofer.iem.dataprovider.taskManager.tasks

import de.fraunhofer.iem.dataprovider.taskManager.Event
import de.fraunhofer.iem.dataprovider.taskManager.ProcessTaskDone
import org.springframework.core.io.ClassPathResource
import org.springframework.core.io.Resource


class OdcTask(projectPath: String, outputPath: String, override val responseChannel: suspend (task: Event) -> Unit) :
    ProcessTask() {

    override val flags: Array<String> = arrayOf(outputPath, projectPath)
    private val resource: Resource = ClassPathResource("scripts/odc.sh")

    override val execPath: String = resource.toString()

    override suspend fun handleProcessReturn(p: Process) {
        logger.info(resource.toString())
        val returnMessage = "Odc finished with exit code ${p.exitValue()}"
        val output = String(p.inputStream.readAllBytes())
        logger.info("Process output $output")
        responseChannel(ProcessTaskDone(taskID, returnMessage))
    }
}
