package de.fraunhofer.iem.dataprovider.taskManager.tasks

import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.launch

sealed class ProcessTask : Task() {
    protected abstract val flags: Array<String>
    protected abstract val execPath: String


    private val mainScope = CoroutineScope(Dispatchers.Default)
    override suspend fun execute() {

        val process = ProcessBuilder(execPath, *flags).start()

        process.onExit().thenApply { p1 ->
            mainScope.launch {
                handleProcessReturn(p1)
            }
        }
    }

    abstract suspend fun handleProcessReturn(p: Process)
}
